# A*

require 'algorithms'
load "./tools.rb"

board = [
	[30, 40, 41, 30],
	[31, 42, 43, 31],
	[30, 20, 21, 30],
	[31, 10, 10, 31],
	[10, 0, 0, 10]
]

# h(n)
# ̔Ֆʂ̏󋵂c̎萔\
def geth(board)
	nrow = board.count
	ncol = board[0].count
	score = 0

	for i in (0...nrow).to_a.reverse
		break if board[i].include?(42)
		for j in 0...ncol
			id = board[i][j] / 10
			score += (id > 1 ? 2 : id)
		end
	end
	score ** 2
end



# nbVɓf[^̒`
# f: FXRA
# move: eʂ̎萔
# parent: eiŒZ[g̎1O̎j
Hashdata = Struct.new(:f, :parent, :pair)
open_hash = {board => Hashdata.new(geth(board), nil)}
close_hash = {}

ans = nil
search_count = 0

starttime = Time.now

until open_hash.empty?
	search_count += 1

	b, v = open_hash.min_by{|k,v| v[:f]}
	b_f = v.f

	close_hash[b] = v
	open_hash.delete(b)

	if is_clear?(b)
		ans = b
		break
	end

	can_move(b).each do |i, j, to|
		newb = move(board_copy(b), i, j, to)
		newcost = b_f - geth(b) + 1 + geth(newb)
		if open_hash.key?(newb)
			if newcost < open_hash[newb].f
				open_hash[newb] = Hashdata.new(newcost, b)
			end
		elsif close_hash.key?(newb)
			if newcost < close_hash[newb].f
				close_hash.delete(newb)
				open_hash[newb] = Hashdata.new(newcost, b)
			end
		else
			open_hash[newb] = Hashdata.new(newcost, b)
		end
	end
end

endtime = Time.now

print_board(board)
puts ''

if !ans
	puts 'No answer found.'
else
	ans_stack = Containers::Stack.new
	s = ans
	ans_stack.push(s)
	while close_hash[s].parent
		ans_stack.push(close_hash[s].parent)
		s = close_hash[s].parent
	end

	i = 0
	lastid = 0
	until ans_stack.empty?
		b = ans_stack.pop
		puts "Move: #{i}"
		print_board(b)
		i += 1
	end
end

puts ''
puts "Search Count: #{search_count}"
puts "Elapsed Time: #{endtime-starttime} s"
