# [DT

require 'algorithms'
load "./tools.rb"

board = [
	[30, 40, 41, 30],
	[31, 42, 43, 31],
	[30, 20, 21, 30],
	[31, 10, 10, 31],
	[10, 0, 0, 10]
]


stack = Containers::Stack.new
stack.push(board)

# nbVɓf[^̒`
# move: eʂ̎萔
# parent: eiŒZ[g̎1O̎j
Hashdata = Struct.new(:move, :parent)
searched = {board => Hashdata.new(0, nil)}

ans = nil
search_count = 0

starttime = Time.now

until stack.empty?
	search_count += 1
	b = stack.pop
	b_move = searched[b].move
	foundflag = false

	can_move(b).shuffle.each do |i, j, to|
		b_new = move(board_copy(b), i, j, to)
		if is_clear?(b_new)
			searched[b_new] = Hashdata.new(b_move + 1, b)
			ans = b_new
			foundflag = true
			break
		elsif !searched[b_new]
			searched[b_new] = Hashdata.new(b_move + 1, b)
			stack.push(b_new)
		end
	end
	break if foundflag
end

endtime = Time.now

print_board(board)
puts ''

if !ans
	puts 'No answer found.'
else
	ans_stack = Containers::Stack.new
	s = ans
	ans_stack.push(s)
	while searched[s].parent
		ans_stack.push(searched[s].parent)
		s = searched[s].parent
	end

	i = 0
	lastid = 0
	until ans_stack.empty?
		b = ans_stack.pop
		puts "Move: #{i}"
		print_board(b)
		i += 1
	end
end

puts ''
puts "Search Count: #{search_count}"
puts "Elapsed Time: #{endtime-starttime} s"
