def board_copy(board)
	ret = []
	board.each do |row|
		ret << row.dup
	end
	ret
end

# Ֆʂo͂
def print_board(board)
	ncol = board[0].count

	puts '-' * (ncol * 3 + 3)
	board.each do |col|
		print('| ')
		col.each do |row|
			printf('%2d ', row)
		end
		puts '|'
	end
	puts '-' * (ncol * 3 + 3)
end

# ƕ̑gݍ킹̔zԂ
def can_move(board)
	ret = []

	nrow = board.count
	ncol = board[0].count

	checked = (0...nrow).collect{Array.new(ncol, false)}

	for i in 0...nrow
		for j in 0...ncol
			unless checked[i][j]
				case board[i][j]
				when 10
					ret << [i, j, :up] if i > 0 && board[i-1][j] == 0
					ret << [i, j, :down] if i < nrow-1 && board[i+1][j] == 0
					ret << [i, j, :left] if j > 0 && board[i][j-1] == 0
					ret << [i, j, :right] if j < ncol-1 && board[i][j+1] == 0
				when 20
					ret << [i, j, :up] if i > 0 && board[i-1][j] == 0 && board[i-1][j+1] == 0
					ret << [i, j, :down] if i < nrow-1 && board[i+1][j] == 0 && board[i+1][j+1] == 0
					ret << [i, j, :left] if j > 0 && board[i][j-1] == 0
					ret << [i, j, :right] if j < ncol-2 && board[i][j+2] == 0
				when 30
					ret << [i, j, :up] if i > 0 && board[i-1][j] == 0
					ret << [i, j, :down] if i < nrow-2 && board[i+2][j] == 0
					ret << [i, j, :left] if j > 0 && board[i][j-1] == 0 && board[i+1][j-1] == 0
					ret << [i, j, :right] if j < ncol-1 && board[i][j+1] == 0 && board[i+1][j+1] == 0
				when 40
					ret << [i, j, :up] if i > 0 && board[i-1][j] == 0 && board[i-1][j+1] == 0
					ret << [i, j, :down] if i < nrow-2 && board[i+2][j] == 0 && board[i+2][j+1] == 0
					ret << [i, j, :left] if j > 0 && board[i][j-1] == 0 && board[i+1][j-1] == 0
					ret << [i, j, :right] if j < ncol-2 && board[i][j+2] == 0 && board[i+1][j+2] == 0
				end
			end
		end
	end
	ret
end

# 𓮂̔zԂ
# 邩ǂ͔fȂ
# z̓Rs[Ȃi㏑j
def move(board, i, j, to)
	case board[i][j]
	when 10
		case to
		when :up
			board[i-1][j] = 10
			board[i][j] = 0
		when :down
			board[i][j] = 0
			board[i+1][j] = 10
		when :left
			board[i][j-1] = 10
			board[i][j] = 0
		when :right
			board[i][j] = 0
			board[i][j+1] = 10
		end
	when 20
		case to
		when :up
			board[i-1][j] = 20
			board[i-1][j+1] = 21
			board[i][j] = 0
			board[i][j+1] = 0
		when :down
			board[i][j] = 0
			board[i][j+1] = 0
			board[i+1][j] = 20
			board[i+1][j+1] = 21
		when :left
			board[i][j-1] = 20
			board[i][j] = 21
			board[i][j+1] = 0
		when :right
			board[i][j] = 0
			board[i][j+1] = 20
			board[i][j+2] = 21
		end
	when 30
		case to
		when :up
			board[i-1][j] = 30
			board[i][j] = 31
			board[i+1][j] = 0
		when :down
			board[i][j] = 0
			board[i+1][j] = 30
			board[i+2][j] = 31
		when :left
			board[i][j-1] = 30
			board[i+1][j-1] = 31
			board[i][j] = 0
			board[i+1][j] = 0
		when :right
			board[i][j] = 0
			board[i+1][j] = 0
			board[i][j+1] = 30
			board[i+1][j+1] = 31
		end
	when 40
		case to
		when :up
			board[i-1][j] = 40
			board[i-1][j+1] = 41
			board[i][j] = 42
			board[i][j+1] = 43
			board[i+1][j] = 0
			board[i+1][j+1] = 0
		when :down
			board[i][j] = 0
			board[i][j+1] = 0
			board[i+1][j] = 40
			board[i+1][j+1] = 41
			board[i+2][j] = 42
			board[i+2][j+1] = 43
		when :left
			board[i][j-1] = 40
			board[i][j] = 41
			board[i][j+1] = 0
			board[i+1][j-1] = 42
			board[i+1][j] = 43
			board[i+1][j+1] = 0
		when :right
			board[i][j] = 0
			board[i][j+1] = 40
			board[i][j+2] = 41
			board[i+1][j] = 0
			board[i+1][j+1] = 42
			board[i+1][j+2] = 43
		end
	end

	board
end

# ՖʂNAǂ𒲍
# clear_range ͎o镝
def is_clear?(board)
	nrow = board.count
	board[nrow-1][1] == 42 && board[nrow-1][2] == 43
end
