load "./tools.rb"

# zu`
#  => 0
# 1~1 => 1
# 1~2 => 2 [0,1]
# 2x1 => 3 [[0],[1]]
# 2x2 => 4 [[0,1],[2,3]]
board = [
	[30, 40, 41, 30],
	[31, 42, 43, 31],
	[30, 20, 21, 30],
	[31, 10, 10, 31],
	[10, 0, 0, 10]
]

print_board(board)

search_count = 0
starttime = Time.now

until is_clear?(board)
	i, j, to = can_move(board).sample
	move(board, i, j, to)
	search_count += 1
	# puts ''
	# puts "Move: #{search_count}"
	# print_board(board)
end

endtime = Time.now
print_board(board)
puts ''
puts "Search Count: #{search_count}"
puts "Elapsed Time: #{endtime-starttime} s"
